package fi.em.formPlugin;

import kd.bos.bill.OperationStatus;
import kd.bos.context.RequestContext;
import kd.bos.form.control.Button;
import kd.bos.form.events.AfterDoOperationEventArgs;
import kd.bos.form.plugin.AbstractFormPlugin;
import kd.bos.url.UrlService;

import java.util.EventObject;

/**
 * @author cjz
 * @date 2024/11/15 11:51
 * @description:薪酬发放计提，调用附件上传按钮
 */
public class SalaryClickPlugin extends AbstractFormPlugin {

    @Override
    public void afterBindData(EventObject e) {
        super.afterBindData(e);
        //新增或可编辑状态
        if(OperationStatus.ADDNEW.equals(getView().getFormShowParameter().getStatus())||OperationStatus.EDIT.equals(getView().getFormShowParameter().getStatus())){
            RequestContext ctx = RequestContext.get();
            String clientPath = UrlService.getDomainContextUrlByTenantCode(ctx.getTenantCode());//拿到完整的客户端网址
            String jspath = clientPath+"/public/thirdjs/salaryupload.js";
            this.getView().executeClientCommand("loadThirdPartyJS",jspath);
        }
    }
}
