package fi.fa.opplugin;

import com.alibaba.druid.util.StringUtils;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.plugin.AbstractOperationServicePlugIn;
import kd.bos.entity.plugin.args.BeginOperationTransactionArgs;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;

public class FaLeaseContractOpPlugin extends AbstractOperationServicePlugIn {
    @Override
    public void beginOperationTransaction(BeginOperationTransactionArgs e) {
        DynamicObject[] dynamicObjects = e.getDataEntities();
        for (int i = 0; i < dynamicObjects.length; i++) {
            if (StringUtils.equals(e.getOperationKey(),"audit")) {
                DynamicObject info = BusinessDataServiceHelper.loadSingle(dynamicObjects[i].getPkValue(), dynamicObjects[i].getDynamicObjectType().getName());
                DynamicObject assetcat = info.getDynamicObject("assetcat");
                Long id = null;
                if (assetcat != null) {
                    id = assetcat.getLong("id");
                }
                Boolean isexempt = info.getBoolean("isexempt");
                DynamicObjectCollection payplanentryentitys = info.getDynamicObjectCollection("payplanentryentity");
                for (DynamicObject payplanentryentity : payplanentryentitys) {
                    payplanentryentity.set("nckd_basedatafield", id);
                    payplanentryentity.set("nckd_checkboxfield", isexempt);
                }
                SaveServiceHelper.save(new DynamicObject[]{info});
            }
        }
    }
}
